#include <iostream>
#include <cmath>
#include <ctime>
using namespace std;
double fabs(double a)
 {
  return (a<0)?-a:a;
 }
struct par
 {
  double x, y;
 };
struct par a, m[200000];
double dist(struct par c, struct par d)
 {
  return sqrt(fabs(c.x-d.x)*fabs(c.x-d.x)+fabs(c.y-d.y)*fabs(c.y-d.y));
 }
bool comp_par(struct par c, struct par d)
 {
  return dist(a, c)<dist(a, d);
 }

int main()
 {
  int n, k;
  double l;
  cin>>a.x>>a.y>>l>>k>>n;
  for(int i=0; i<n; i++)
   {
    cin>>m[i].x>>m[i].y; 
   }
  sort(m, m+n, comp_par);
  cout.precision(4);
  int ins=0;
  double distam=dist(a, m[k-1]);
  for(int i=0; i<n; i++)
   {
    if(dist(a, m[i])<=distam) ins++;
    else if(dist(a, m[i])>distam) break;
   }
  if(ins>k) { cout<<"NO SOLUTION"<<endl; return 0; }
  if(dist(a, m[k-1])<l) cout<<"-"<<fixed<<l-distam<<endl;
  else if(dist(a, m[k-1])>l) cout<<"+"<<fixed<<distam-l<<endl;
  else cout<<0<<endl;
  return 0;
 }
  
