#include <iostream>
#include <cmath>
#include <cstdio>
using namespace std;
struct point{
	double x, y;
};
point p[ 1 << 20 ], a;
double dists[ 1<< 20], l;
int  k, n;
void scan(){
	cin >> a.x >> a.y >> l >> k >> n;
	for ( int i = 0; i < n; ++i )
		cin >> p[ i ].x >> p[ i ].y;
}
double dist(point q, point w){
	return sqrt( ( q.x - w.x ) * (  q.x - w.x ) + ( q.y - w.y ) * ( q.y - w.y ) );
}
bool cmp(point a1, point b1) {
	return dist( a1, a ) < dist ( b1, a);
}
void solve(){
	sort( p, p + n, cmp );--k;
	for ( int i = 0; i < n; ++i)
		dists[ i ] = dist ( p[ i ], a);
	if ( dists[ k ] == dists[ k + 1]){cout << "NO SOLUTION\n"; return;}
	if ( dists[k] > l)
		printf( "+%.4f\n",dists[ k ] - l );
	if ( dists[k] < l)
		printf( "%.4f\n",dists[ k ] - l );
	if ( dists[k]  == l)
		printf( "0.0000\n");
	}
int main(){
	scan();
	solve();
}
